# -*- coding: utf-8 -*-
from selenium import webdriver
from selenium.webdriver.common.by import By
from selenium.webdriver.support.ui import Select
from selenium.common.exceptions import NoSuchElementException
from selenium.common.exceptions import NoAlertPresentException
import unittest, time
from pyvirtualdisplay import Display

class UsersAssertFiltersUserTypeAssociation(unittest.TestCase):
    def setUp(self):
        self.display = Display(visible=0, size=(1920, 1080))
        self.display.start()
        profile = webdriver.FirefoxProfile()
        # setting the locale french : ‘fr’
        profile.set_preference("intl.accept_languages","fr")
        self.driver = webdriver.Firefox(profile)
        self.driver.set_window_size(1920,1080)
        self.driver.implicitly_wait(20)
        self.base_url = "http://192.168.10.31:8080"
        self.verificationErrors = []
        self.accept_next_alert = True

    def test_users_assert_filters_user_type_association(self):
        driver = self.driver
        driver.get(self.base_url + "/pages")
        driver.find_element_by_link_text("Utilisateurs").click()
        Select(driver.find_element_by_name("userType")).select_by_visible_text("Association")
        driver.find_element_by_xpath("(//button[@type='submit'])[2]").click()
        self.assertFalse(self.is_element_present(By.CSS_SELECTOR, "div.stamp.badge.badgeCompany"))
        self.assertFalse(self.is_element_present(By.CSS_SELECTOR, "div.stamp.badge.badgeAdministration"))
        self.assertFalse(self.is_element_present(By.CSS_SELECTOR, "div.stamp.badge.badgePerson"))
        self.assertTrue(self.is_element_present(By.CSS_SELECTOR, "div.stamp.badge.badgeAsso"))

    def is_element_present(self, how, what):
        try: self.driver.find_element(by=how, value=what)
        except NoSuchElementException as e: return False
        return True

    def is_alert_present(self):
        try: self.driver.switch_to_alert()
        except NoAlertPresentException as e: return False
        return True

    def close_alert_and_get_its_text(self):
        try:
            alert = self.driver.switch_to_alert()
            alert_text = alert.text
            if self.accept_next_alert:
                alert.accept()
            else:
                alert.dismiss()
            return alert_text
        finally: self.accept_next_alert = True

    def tearDown(self):
        self.driver.quit()
        self.assertEqual([], self.verificationErrors)

if __name__ == "__main__":
    unittest.main()
